import xmltodict

from fec_apphistory.conf import settings
from rest_framework import status

from base_app import utils as base_app_utils
from fec_apphistory import constants as fec_apphistory_constants
from fec_apphistory import serializers as fec_apphistory_serializers


class AppHistoryUtil(base_app_utils.GenericSoapAsyncUtil):
    request_serializer_class = fec_apphistory_serializers.GetAppHistorySerializer
    response_serializer_class= fec_apphistory_serializers.ReturnAppHistorySerializer
    request_url = settings.APPHISTORY_WSDL
    username = settings.APPHISTORY_USERNAME
    password = settings.APPHISTORY_PASSWORD
    method_name = 'GetAppLoanHistory'
    success_code_list = [1, '1', 3, '3']
    success_code_eval = "data.get('data', {}).get('Sys', {}).get('Code')"
    retry_code_list = [2, '2', 3, '3']
    return_codes = fec_apphistory_constants.APPHISTORY_RETURN_CODES

    def check_for_retryable_response(self, **data):
        """
        utility to check if the response from soap api is valid
        :param data:
        :return:
        """
        response_code = eval(self.success_code_eval)
        print(response_code)
        if response_code in self.retry_code_list:
            print("in retry")
            return data, status.HTTP_200_OK, ''
        elif response_code in self.return_codes.keys():
            error = self.return_codes.get(response_code, {})
            print("should not retry")
            return data, error.get('https_status'), error
        else:
            print("should not retry")
            error = self.unknown_error
            return data, error.get('http_status'), error